"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class PedigreeInjectRD(ProtocolElement):
    """
    Record for tiered variant injection as part of the data intake for CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "metadata",
        "pedigree",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import cva as cva_1_5_0
        from protocols.protocol_7_4 import participant as participant_1_2_0

        return {
            "metadata": cva_1_5_0.InjectionMetadata,
            "pedigree": participant_1_2_0.Pedigree,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import cva as cva_1_5_0
        from protocols.protocol_7_4 import participant as participant_1_2_0

        return {
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_5_0.InjectionMetadata,
            "org.gel.models.participant.avro.Pedigree": participant_1_2_0.Pedigree,
            "org.gel.models.cva.avro.PedigreeInjectRD": cva_1_5_0.PedigreeInjectRD,
        }

    __slots__ = [
        "metadata",
        "pedigree",
    ]

    def __init__(
        self,
        metadata,
        pedigree,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_0.PedigreeInjectRD model.

        :param metadata:
            Metadata on the report events in the clinical report
        :type metadata: InjectionMetadata
        :param pedigree:
            Rare disease pedigree
        :type pedigree: Pedigree
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
